Codeforces 671A Recycling Bottles 【dp】

题目链接:Codeforces 671A Recycling Bottles

A. Recycling Bottles
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
It was recycling day in Kekoland. To celebrate it Adil and Bera went to Central Perk where they can take bottles from the ground and put them into a recycling bin.

We can think Central Perk as coordinate plane. There are n bottles on the ground, the i-th bottle is located at position (xi, yi). Both Adil and Bera can carry only one bottle at once each.

For both Adil and Bera the process looks as follows:

Choose to stop or to continue to collect bottles.
If the choice was to continue then choose some bottle and walk towards it.
Pick this bottle and walk to the recycling bin.
Go to step 1.
Adil and Bera may move independently. They are allowed to pick bottles simultaneously, all bottles may be picked by any of the two, it’s allowed that one of them stays still while the other one continues to pick bottles.

They want to organize the process such that the total distance they walk (the sum of distance walked by Adil and distance walked by Bera) is minimum possible. Of course, at the end all bottles should lie in the recycling bin.

Input
First line of the input contains six integers ax, ay, bx, by, tx and ty (0 ≤ ax, ay, bx, by, tx, ty ≤ 109) — initial positions of Adil, Bera and recycling bin respectively.

The second line contains a single integer n (1 ≤ n ≤ 100 000) — the number of bottles on the ground.

Then follow n lines, each of them contains two integers xi and yi (0 ≤ xi, yi ≤ 109) — position of the i-th bottle.

It’s guaranteed that positions of Adil, Bera, recycling bin and all bottles are distinct.

Output
Print one real number — the minimum possible total distance Adil and Bera need to walk in order to put all bottles into recycling bin. Your answer will be considered correct if its absolute or relative error does not exceed 10 - 6.

Namely: let’s assume that your answer is a, and the answer of the jury is b. The checker program will consider your answer correct if .

Examples
input
3 1 1 2 0 0
3
1 1
2 1
2 3
output
11.084259940083
input
5 0 4 2 2 0
5
5 2
3 0
5 5
3 5
3 3
output
33.121375178000
Note
Consider the first sample.

Adil will use the following path: .

Bera will use the following path: .

Adil’s path will be units long, while Bera’s path will be units long.

题意:给定n个垃圾堆的坐标,已知两个人A、B以及垃圾回收站的坐标。要求每次只能让一个人工作,且每处理一个垃圾堆必须把垃圾放进回收站。现在要把所有垃圾扔进回收站,问你A、B两人所走的最小距离。

思路:dp[i][j][k][l]表示处理前i个点且用第j个人(0表示A,1表示B)走第i个点,A的位置状态为k,B的位置状态为l的最优解。位置状态为0时表示在回收站,反之在起点。
因为在处理某个点的过程中,从起点开始走可能不是最优的,这时需要从回收站出发才是最优的。
用dp[i][2][0][0]表示处理前i个点两人均在回收站的状态,因为最优解可能产生——先到第i+1个点,再由回收站到达前面的点。

AC代码:

#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
using namespace std;
const int MAXN = 1e5 + 10;
double dp[MAXN][3][2][2];
double d1[MAXN], d2[MAXN], d3[MAXN];
double dis(int x1, int y1, int x2, int y2) {
    return sqrt(1LL * (x1 - x2) * (x1 - x2) * 1.0 + 1LL * (y1 - y2) * (y1 - y2));
}
void Solve(double &x, double y) {
    if(y == -1) return ;
    if(x == -1) x = y;
    else x = min(x, y);
}
int main()
{
    int ax, ay, bx, by, tx, ty;
    while(scanf("%d%d%d%d%d%d", &ax, &ay, &bx, &by, &tx, &ty) != EOF) {
        int n; scanf("%d", &n);
        for(int i = 1; i <= n; i++) {
            int x, y; scanf("%d%d", &x, &y);
            d1[i] = dis(ax, ay, x, y);
            d2[i] = dis(bx, by, x, y);
            d3[i] = dis(tx, ty, x, y);
            dp[i][0][1][0] = dp[i][0][1][1] = dp[i][1][0][1] = dp[i][1][1][1] = -1;
            dp[i][2][0][0] = -1;
        }
        dp[1][2][0][0] = 2 * d3[1];
        dp[1][0][1][0] = d1[1] + d3[1];
        dp[1][1][0][1] = d2[1] + d3[1];
        for(int i = 1; i < n; i++) {
            Solve(dp[i+1][2][0][0], dp[i][2][0][0] + 2 * d3[i+1]);
            Solve(dp[i+1][0][1][0], dp[i][2][0][0] + d1[i+1] + d3[i+1]);
            Solve(dp[i+1][1][0][1], dp[i][2][0][0] + d2[i+1] + d3[i+1]);

            if(dp[i][0][1][0] != -1) {
                Solve(dp[i+1][0][1][0], dp[i][0][1][0] + 2 * d3[i+1]);
                Solve(dp[i+1][1][1][1], dp[i][0][1][0] + d2[i+1] + d3[i+1]);
            }

            if(dp[i][0][1][1] != -1) {
                Solve(dp[i+1][0][1][1], dp[i][0][1][1] + 2 * d3[i+1]);
                Solve(dp[i+1][1][1][1], dp[i][0][1][1] + 2 * d3[i+1]);
            }

            if(dp[i][1][0][1] != -1) {
                Solve(dp[i+1][0][1][1], dp[i][1][0][1] + d1[i+1] + d3[i+1]);
                Solve(dp[i+1][1][0][1], dp[i][1][0][1] + 2 * d3[i+1]);
            }

            if(dp[i][1][1][1] != -1) {
                Solve(dp[i+1][0][1][1], dp[i][1][1][1] + 2 * d3[i+1]);
                Solve(dp[i+1][1][1][1], dp[i][1][1][1] + 2 * d3[i+1]);
            }
        }
        double ans = -1;
        //printf("%.8lf %.8lf %.8lf %.8lf\n", dp[n][0][1][0], dp[n][0][1][1], dp[n][1][0][1], dp[n][1][1][1]);
        Solve(ans, dp[n][0][1][0]); Solve(ans, dp[n][0][1][1]);
        Solve(ans, dp[n][1][0][1]); Solve(ans, dp[n][1][1][1]);
        printf("%.8lf\n", ans);
    }
    return 0;
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
区间DP是一种动态规划的方法,用于解决区间范围内的问题。在Codeforces竞赛中,区间DP经常被用于解决一些复杂的字符串或序列相关的问题。 在区间DP中,dp[i][j]表示第一个序列前i个元素和第二个序列前j个元素的最优解。具体的转移方程会根据具体的问题而变化,但是通常会涉及到比较两个序列的元素是否相等,然后根据不同的情况进行状态转移。 对于区间长度为1的情况,可以先进行初始化,然后再通过枚举区间长度和区间左端点,计算出dp[i][j]的值。 以下是一个示例代码,展示了如何使用区间DP来解决一个字符串匹配的问题: #include <cstdio> #include <cstring> #include <string> #include <iostream> #include <algorithm> using namespace std; const int maxn=510; const int inf=0x3f3f3f3f; int n,dp[maxn][maxn]; char s[maxn]; int main() { scanf("%d", &n); scanf("%s", s + 1); for(int i = 1; i <= n; i++) dp[i][i] = 1; for(int i = 1; i <= n; i++) { if(s[i] == s[i - 1]) dp[i][i - 1] = 1; else dp[i][i - 1] = 2; } for(int len = 3; len <= n; len++) { int r; for(int l = 1; l + len - 1 <= n; l++) { r = l + len - 1; dp[l][r] = inf; if(s[l] == s[r]) dp[l][r] = min(dp[l + 1][r], dp[l][r - 1]); else { for(int k = l; k <= r; k++) { dp[l][r] = min(dp[l][r], dp[l][k] + dp[k + 1][r]); } } } } printf("%d\n", dp[n]); return 0; } 希望这个例子能帮助你理解区间DP的基本思想和应用方法。如果你还有其他问题,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值